const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const sales_order_lines = sequelize.define(
    'sales_order_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

line_number: {
        type: DataTypes.INTEGER,
      
      

      },

ordered_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_price: {
        type: DataTypes.DECIMAL,
      
      

      },

discount_percent: {
        type: DataTypes.DECIMAL,
      
      

      },

line_total: {
        type: DataTypes.DECIMAL,
      
      

      },

need_by_at: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  sales_order_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.sales_order_lines.belongsTo(db.sales_orders, {
      as: 'sales_order',
      foreignKey: {
        name: 'sales_orderId',
      },
      constraints: false,
    });

    db.sales_order_lines.belongsTo(db.items, {
      as: 'item',
      foreignKey: {
        name: 'itemId',
      },
      constraints: false,
    });

    db.sales_order_lines.belongsTo(db.uoms, {
      as: 'uom',
      foreignKey: {
        name: 'uomId',
      },
      constraints: false,
    });




    db.sales_order_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.sales_order_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return sales_order_lines;
};


